#include "commandimp.h"
#include <sys/wait.h>

extern int Copy(MLS::Selection &, std::string);
extern int Move(MLS::Selection &, std::string);

namespace MLS {

void CommandImp::CopyClip()
{
	g_MainFrame->tClipboard.Set(panel->GetSelection(), CLIP_COPY);
}

void CommandImp::CutClip()
{
	g_MainFrame->tClipboard.Set(panel->GetSelection(), CLIP_CUT);
}

void CommandImp::PasteClip()
{
	ClipState state = g_MainFrame->tClipboard.GetState();
	
	if (state == CLIP_NONE) return;
	
	if (state == CLIP_COPY)
	{
		::Copy(g_MainFrame->tClipboard.Get(), panel->path);
		Refresh();
	}
	else if (state == CLIP_CUT)
	{
		::Move(g_MainFrame->tClipboard.Get(), panel->path);
		Refresh();		
	}
	
	
}

void CommandImp::ViewScreen( )
{
	def_prog_mode();
	endwin();
	
	cbreak();
	noecho();
		
	getch();
	refresh();
}

///	@brief	명령어를 실행한다.
///	@param	cmd		명령어및 인자
///	@param	bPause	명령어를 실행시키고 종료시 잠tClipboard시 정지시킬지 여부 
/// @param	bFork	Fork할 것인지?
///	@return	명령어 실행 결과
int CommandImp::Run( const std::string &cmd, bool bPause, bool bFork)
{
	def_prog_mode();
	endwin();
		
	int status;
	
	/*
	// 이것은 사용자가 x-window 프로그램을 이용할 때나 사용 가능 할 듯
	if (bFork)
	{
		pid_t pid = fork();	
		if (pid == -1)
		{// forking error
			MsgBox("Error", "Forking");
		}
		else if (pid == 0)
		{// 자식
			char *argv[4];
			argv[0] = "sh";
			argv[1] = "-c";
			argv[2] = (char *)cmd.c_str();
			argv[3] = 0;
			execv("/bin/sh", argv);	
			
			LOG("CHILD EXIT");
			exit(0);
		}
		
		// 부모
		int nRt = waitpid(pid, &status, 0);
				
		if(WIFSIGNALED(status))
		{
			LOG("Process wait :: %d", WTERMSIG(status));
		}
		
		LOG("CHILD EXIT :: WAIT PID");
	}
	else*/
	{
		status = system(cmd.c_str());
	}
	
	if (bPause)
	{
		cbreak();
		noecho();
		
		printf("\nPress any key to return Mls...\n");
		getch();
	}
	refresh();	
	
	Refresh();
	
	return status;
}

};
